local addon, ns = ...
local cfg = ns.cfg
local mAB = ns.mAB

local myclass = select(2, UnitClass("player"))

if not cfg.enable_action_bars then return end
if IsAddOnLoaded("Dominos") then return end

--[[ ---- Compatability for old cfg.lua
if not cfg.config_extrabar then cfg.config_extrabar = {"H", 1, 12, 30, cfg.spacing, false, false, false, 1, .3, ["Position"] = { a= "BOTTOMRIGHT",	x=	-26,	y= 260	}} end 
if not cfg.config_micromenu then cfg.config_micromenu = { cfg.hide_micromenu, cfg.micromenu_onmouseover, cfg.micromenu_scale, ["Position"] = {a= "BOTTOMRIGHT", x= -26, y= 345}} end
if not cfg.config_exitvehiclebtn then cfg.config_exitvehiclebtn = {cfg.hide_exit_vehicle_button, cfg.EVB_user_placed, ["Position"] = {a= "BOTTOM", x= -380, y= 238}} end
if cfg.frame_positions then
	cfg.frame_positions[1] = cfg.config_mainbar["Position"]
	cfg.frame_positions[2] = cfg.config_bottomleftbar["Position"]
	cfg.frame_positions[3] = cfg.config_bottomrightbar["Position"]
	cfg.frame_positions[4] = cfg.config_leftbar["Position"]
	cfg.frame_positions[5] = cfg.config_rightbar["Position"]
	cfg.frame_positions[6] = cfg.config_shapeshiftbar["Position"]
	cfg.frame_positions[7] = cfg.config_petbar["Position"]
	cfg.frame_positions[8] = cfg.config_extrabar["Position"] -- ...
	cfg.frame_positions[9] = cfg.config_totembar["Position"]
	cfg.frame_positions[11] = cfg.config_micromenu["Position"]
	cfg.frame_positions[12] = cfg.config_raidiconbar["Position"]
	cfg.frame_positions[13] = cfg.config_markerflarebar["Position"]
	cfg.frame_positions[14] = cfg.config_exitvehiclebtn["Position"]
end

if not cfg.config_totembar then	cfg.config_totembar = {cfg.totembar_enable_timers, 32, 8, false, cfg.totembar_alpha} end
if cfg.frame_positions then
	if cfg.frame_positions[8].a == "BOTTOM" and cfg.frame_positions[8].x == -292 and cfg.frame_positions[8].y == 359 then
		cfg.frame_positions[8] = {a= cfg.frame_positions[5].a, x=	cfg.frame_positions[5].x, y= cfg.frame_positions[5].y+35}
		if cfg.frame_positions[6].a == "BOTTOMRIGHT" and cfg.frame_positions[6].x == -250 and cfg.frame_positions[6].y == 260 then
			cfg.frame_positions[6] = {a= cfg.frame_positions[6].a, x=	cfg.frame_positions[6].x, y= cfg.frame_positions[6].y+35}
		end
		if cfg.frame_positions[11].a == "BOTTOMRIGHT" and cfg.frame_positions[11].x == -26 and cfg.frame_positions[11].y == 305 then
			cfg.frame_positions[11] = {a= cfg.frame_positions[11].a, x=	cfg.frame_positions[11].x, y= cfg.frame_positions[11].y+40}
		end
	end
end ]]

-- enabling default action bars
local f = CreateFrame"Frame"
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("VARIABLES_LOADED")
f:SetScript("OnEvent", function()
	SHOW_MULTI_ACTIONBAR_1 = 1
	SHOW_MULTI_ACTIONBAR_2 = 1
	SHOW_MULTI_ACTIONBAR_3 = 1
	SHOW_MULTI_ACTIONBAR_4 = 1
	MultiActionBar_Update()
	SetActionBarToggles(1, 1, 1, 1)
	--SetCVar("alwaysShowActionBars", 0, true) 
end)

---- Modifying default action bars
-- Creating holder frames for each bar
local mainbar = mAB.CreateHolder("holder_MainBar", cfg.config_mainbar["Position"])
local bottomleftbar = mAB.CreateHolder("holder_MultiBarBottomLeftBar", cfg.config_bottomleftbar["Position"])
local bottomrightbar = mAB.CreateHolder("holder_MultiBarBottomRightBar", cfg.config_bottomrightbar["Position"])
local leftbar = mAB.CreateHolder("holder_MultiBarLeftBar", cfg.config_leftbar["Position"])
local rightbar = mAB.CreateHolder("holder_MultiBarRightBar", cfg.config_rightbar["Position"])
local shapeshiftbar = mAB.CreateHolder("holder_ShapeShiftBar", cfg.config_shapeshiftbar["Position"])
local extrabar = mAB.CreateHolder("holder_ExtraBar", cfg.config_extrabar["Position"])
local petbar -- some mombo jumbo stuff for pet bar positioning for Shamans (specifically for MonoUI)
if myclass == "SHAMAN" then
	petbar = mAB.CreateHolder("holder_PetBar", {a= cfg.config_petbar["Position"].a, x=	cfg.config_petbar["Position"].x*1.25, y= cfg.config_petbar["Position"].y*1.25+cfg.config_totembar[2]+10})
else
	petbar = mAB.CreateHolder("holder_PetBar", {a= cfg.config_petbar["Position"].a, x=	cfg.config_petbar["Position"].x*1.25, y= cfg.config_petbar["Position"].y*1.25})
end

-- MainBar is a special bar and like everything special it requires SPECIAL handling
-- Major credits to Tukz for figuring out the way to operate with RegisterStateDriver()
local Page = {
    ["DRUID"] = "[bonusbar:1,nostealth] 7; [bonusbar:1,stealth] %s; [bonusbar:2] 8; [bonusbar:3] 9; [bonusbar:4] 10;",
    ["WARRIOR"] = "[bonusbar:1] 7; [bonusbar:2] 8; [bonusbar:3] 9;",
    ["PRIEST"] = "[bonusbar:1] 7;",
    ["ROGUE"] = "[bonusbar:1] 7; [form:3] 8;",
    ["WARLOCK"] = "[form:2] 7;",
    ["DEFAULT"] = "[bar:2] 2; [bar:3] 3; [bar:4] 4; [bar:5] 5; [bar:6] 6; [bonusbar:5] 11;",
}
local function GetBar()
    local condition = Page["DEFAULT"]
    local page = Page[myclass]
    if page then
      if myclass == "DRUID" then
        -- Handles prowling, prowling has no real stance, so this is a hack which utilizes the Tree of Life bar for non-resto druids.
        if IsSpellKnown(33891) then -- Tree of Life form
          page = page:format(7)
        else
          page = page:format(8)
        end
      end
      condition = condition.." "..page
    end
    condition = condition.." 1"
    return condition
end
local first_row_num = math.floor(cfg.config_mainbar[3]/cfg.config_mainbar[2])
if cfg.config_mainbar[1] == "H" then
	if cfg.config_mainbar[2] == 1 then
		mainbar:SetWidth(cfg.config_mainbar[4]*cfg.config_mainbar[3] + cfg.config_mainbar[5]*(cfg.config_mainbar[3]-1))
		mainbar:SetHeight(cfg.config_mainbar[4])
	else
		mainbar:SetWidth(cfg.config_mainbar[4]*first_row_num + cfg.config_mainbar[5]*(first_row_num-1))
		mainbar:SetHeight(cfg.config_mainbar[4]*cfg.config_mainbar[2]+cfg.config_mainbar[5])
	end
else
	if cfg.config_mainbar[2] == 1 then
		mainbar:SetWidth(cfg.config_mainbar[4])
		mainbar:SetHeight(cfg.config_mainbar[4]*cfg.config_mainbar[3] + cfg.config_mainbar[5]*(cfg.config_mainbar[3]-1))
	else
		mainbar:SetWidth(cfg.config_mainbar[4]*cfg.config_mainbar[2]+cfg.config_mainbar[5])
		mainbar:SetHeight(cfg.config_mainbar[4]*first_row_num + cfg.config_mainbar[5]*(first_row_num-1))
	end
end
mainbar:RegisterEvent("PLAYER_LOGIN")
mainbar:RegisterEvent("PLAYER_ENTERING_WORLD")
mainbar:RegisterEvent("KNOWN_CURRENCY_TYPES_UPDATE")
mainbar:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
mainbar:RegisterEvent("BAG_UPDATE")
mainbar:RegisterEvent("PLAYER_REGEN_DISABLED")
mainbar:RegisterEvent("PLAYER_REGEN_ENABLED")
mainbar:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
mainbar:SetScript("OnEvent", function(self, event, ...)
if event == "PLAYER_LOGIN" or event == "ACTIVE_TALENT_GROUP_CHANGED" then
    local button, buttons
	for i = 1, NUM_ACTIONBAR_BUTTONS do
		button = _G["ActionButton"..i]
		self:SetFrameRef("ActionButton"..i, button)
	end  
	self:Execute([[
		buttons = table.new()
		for i = 1, 12 do
			table.insert(buttons, self:GetFrameRef("ActionButton"..i))
		end
		]])
	self:SetAttribute("_onstate-page", [[ 
		  for i, button in ipairs(buttons) do
			button:SetAttribute("actionpage", tonumber(newstate))
		  end
		]])
	RegisterStateDriver(self, "page", GetBar())
elseif event == "PLAYER_ENTERING_WORLD" then
	local button
		for i = 1, cfg.config_mainbar[3] do
			button = _G["ActionButton"..i]
			button:ClearAllPoints()
			button:SetSize(cfg.config_mainbar[4],cfg.config_mainbar[4])
			button:SetParent(self)
			previous = _G["ActionButton"..i-1]
			if i == 1 then
				button:SetPoint("TOPLEFT", mainbar, "TOPLEFT", 0,0)
			else
				if cfg.config_mainbar[1] == "H" then
					if cfg.config_mainbar[2] == 1 then
						button:SetPoint("TOPLEFT", previous, "TOPRIGHT", cfg.config_mainbar[5], 0)
					else
						button:SetPoint("TOPLEFT", previous, "TOPRIGHT", cfg.config_mainbar[5], 0)
						if i == first_row_num+1 then
							button:SetPoint("TOPLEFT", _G["ActionButton"..(i-first_row_num)], "BOTTOMLEFT", 0, -cfg.config_mainbar[5])
						end
						if i==first_row_num*2+1 then
							button:SetPoint("TOPLEFT", _G["ActionButton"..(i-first_row_num)], "BOTTOMLEFT", 0, -cfg.config_mainbar[5])
						end
					end
				else
					if cfg.config_mainbar[2] == 1 then
						button:SetPoint("TOPLEFT", previous, "BOTTOMLEFT", 0, -cfg.config_mainbar[5])
					else
						button:SetPoint("TOPLEFT", previous, "BOTTOMLEFT", 0, -cfg.config_mainbar[5])
						if i == first_row_num+1 then
							button:SetPoint("TOPLEFT", _G["ActionButton"..(i-first_row_num)], "TOPRIGHT", cfg.config_mainbar[5], 0)
						end
						if i==first_row_num*2+1 then
							button:SetPoint("TOPLEFT", _G["ActionButton"..(i-first_row_num)], "TOPRIGHT", cfg.config_mainbar[5], 0)
						end
					end
				end
			end
		end
	else
		MainMenuBar_OnEvent(self, event, ...)
	end
	-- visibility options for mainbar
	if cfg.config_mainbar[6] then mainbar:Hide() return end
	if cfg.config_mainbar[8] then 
		mainbar:Hide()
		if event == "PLAYER_REGEN_DISABLED" then 
			mainbar:Show()
		elseif event == "PLAYER_REGEN_ENABLED" then 
			mainbar:Hide()
		end
	end
end)

---- Forging action bars
-- parenting action buttons to our holders
MultiBarBottomLeft:SetParent(bottomleftbar)
MultiBarBottomRight:SetParent(bottomrightbar)
MultiBarLeft:SetParent(leftbar)
MultiBarRight:SetParent(rightbar)
ShapeshiftBarFrame:SetParent(shapeshiftbar)
PetActionBarFrame:SetParent(petbar)
petbar:SetScale(0.800)

-- hiding posses bar since it's useless
PossessBarFrame:SetParent(shapeshiftbar)
PossessBarFrame:SetScale(0.0001)
PossessBarFrame:SetAlpha(0)

-- apply style settings
mAB.SetBar(bottomleftbar, "MultiBarBottomLeftButton", 1, NUM_ACTIONBAR_BUTTONS, unpack(cfg.config_bottomleftbar))
mAB.SetBar(bottomrightbar, "MultiBarBottomRightButton", 1, NUM_ACTIONBAR_BUTTONS, unpack(cfg.config_bottomrightbar))
mAB.SetBar(shapeshiftbar, "ShapeshiftButton", 1, NUM_SHAPESHIFT_SLOTS, unpack(cfg.config_shapeshiftbar))
mAB.SetBar(leftbar, "MultiBarLeftButton", 1, NUM_ACTIONBAR_BUTTONS, unpack(cfg.config_leftbar))
mAB.SetBar(rightbar, "MultiBarRightButton", 1, NUM_ACTIONBAR_BUTTONS, unpack(cfg.config_rightbar))
mAB.SetBar(petbar, "PetActionButton", 1, NUM_PET_ACTION_SLOTS, unpack(cfg.config_petbar))
mAB.SetExtraBar(extrabar, "ExtraBarButton", 13, 24, unpack(cfg.config_extrabar))

-- mouseover functionality
mAB.SetBarAlpha(mainbar, "ActionButton", NUM_ACTIONBAR_BUTTONS, cfg.config_mainbar[7], cfg.config_mainbar[9], cfg.config_mainbar[10])
mAB.SetBarAlpha(bottomleftbar, "MultiBarBottomLeftButton", NUM_ACTIONBAR_BUTTONS, cfg.config_bottomleftbar[7], cfg.config_bottomleftbar[9], cfg.config_bottomleftbar[10])
mAB.SetBarAlpha(bottomrightbar, "MultiBarBottomRightButton", NUM_ACTIONBAR_BUTTONS, cfg.config_bottomrightbar[7], cfg.config_bottomrightbar[9], cfg.config_bottomrightbar[10])
mAB.SetBarAlpha(shapeshiftbar, "ShapeshiftButton", NUM_SHAPESHIFT_SLOTS, cfg.config_shapeshiftbar[7], cfg.config_shapeshiftbar[9], cfg.config_shapeshiftbar[10])
mAB.SetBarAlpha(leftbar, "MultiBarLeftButton", NUM_ACTIONBAR_BUTTONS, cfg.config_leftbar[7], cfg.config_leftbar[9], cfg.config_leftbar[10])
mAB.SetBarAlpha(rightbar, "MultiBarRightButton", NUM_ACTIONBAR_BUTTONS, cfg.config_rightbar[7], cfg.config_rightbar[9], cfg.config_rightbar[10])
mAB.SetBarAlpha(petbar, "PetActionButton", NUM_PET_ACTION_SLOTS, cfg.config_petbar[7], cfg.config_petbar[9], cfg.config_petbar[10])
mAB.SetBarAlpha(extrabar, "ExtraBarButton", NUM_ACTIONBAR_BUTTONS, cfg.config_extrabar[7], cfg.config_extrabar[9], cfg.config_extrabar[10])

-- apply visibility conditions
if cfg.config_bottomleftbar[6] then bottomleftbar:Hide() elseif cfg.config_bottomleftbar[8] then mAB.ShowInCombat(bottomleftbar) end
if cfg.config_bottomrightbar[6] then bottomrightbar:Hide() elseif cfg.config_bottomrightbar[8] then mAB.ShowInCombat(bottomrightbar) end
if cfg.config_leftbar[6] then leftbar:Hide() elseif cfg.config_leftbar[8] then mAB.ShowInCombat(leftbar) end
if cfg.config_rightbar[6] then rightbar:Hide() elseif cfg.config_rightbar[8] then mAB.ShowInCombat(rightbar) end
if cfg.config_shapeshiftbar[6] then shapeshiftbar:Hide() elseif cfg.config_shapeshiftbar[8] then mAB.ShowInCombat(shapeshiftbar) end
if cfg.config_petbar[6] then petbar:Hide() elseif cfg.config_petbar[8] then mAB.ShowInCombat(petbar) end
if cfg.config_extrabar[6] then extrabar:Hide() elseif cfg.config_extrabar[8] then mAB.ShowInCombat(extrabar) end

-- hiding default frames and textures
MainMenuBar:EnableMouse(false)
MainMenuBar:SetScale(0.0001)
VehicleMenuBar:EnableMouse(false)
VehicleMenuBar:SetScale(0.0001)
PetActionBarFrame:EnableMouse(false)
MainMenuBarMaxLevelBar:EnableMouse(false)
local FramesToHide = {
	MainMenuBar, 
	MainMenuBarArtFrame, 
	BonusActionBarFrame, 
	VehicleMenuBar,
	PossessBarFrame}
for _, f in pairs(FramesToHide) do
    if f:GetObjectType() == "Frame" then
      f:UnregisterAllEvents()
    end
    if f ~= MainMenuBar then --patch 4.0.6 fix, credits to tukz
      f:HookScript("OnShow", function(s) s:Hide(); end)
      f:Hide()
	end
    f:SetAlpha(0)
end

-- exit vehicle button for the lazy ones
local ve = CreateFrame("BUTTON", "holder_VEB", UIParent, "SecureActionButtonTemplate")
ve:SetSize(cfg.config_mainbar[4]+10,cfg.config_mainbar[4]+10)
if cfg.config_exitvehiclebtn[2] then 
	ve:SetPoint(cfg.config_exitvehiclebtn["Position"].a, cfg.config_exitvehiclebtn["Position"].x, cfg.config_exitvehiclebtn["Position"].y)
else
	ve:SetPoint("CENTER", ActionButton8, "CENTER", cfg.config_mainbar[5]/2, 0)
end
ve:RegisterForClicks("AnyUp")
ve:SetScript("OnClick", function() VehicleExit() end)
ve:SetNormalTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Up")
ve:SetPushedTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Down")
ve:SetHighlightTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Down")
ve:SetAlpha(0)
-- adding border so it fits our bars general style
local veh = CreateFrame("Frame",nil,ve)
veh:SetAllPoints(ve)
veh:SetParent(ve)
veh:SetFrameLevel(31)
veh:EnableMouse(false)
local veb = veh:CreateTexture(cfg.textures_normal)
veb:SetTexture(cfg.textures_normal)
veb:SetPoint("TOPLEFT",4,-5)
veb:SetPoint("BOTTOMRIGHT",-6,5)
veb:SetVertexColor(0,0,0)
ve:Hide()
if not cfg.config_exitvehiclebtn[1] then
	ve:Show()
	ve:RegisterEvent("UNIT_ENTERING_VEHICLE")
	ve:RegisterEvent("UNIT_ENTERED_VEHICLE")
	ve:RegisterEvent("UNIT_EXITING_VEHICLE")
	ve:RegisterEvent("UNIT_EXITED_VEHICLE")
	ve:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	ve:SetScript("OnEvent", function(self, event, ...)
		local arg1 = ...;
		if(((event=="UNIT_ENTERING_VEHICLE") or (event=="UNIT_ENTERED_VEHICLE")) and arg1 == "player") then
			ve:SetAlpha(1)
			ve:SetScript("OnEnter", function(self) 
				veb:SetVertexColor(cfg.colors.highlight.r, cfg.colors.highlight.g, cfg.colors.highlight.b)
			end)
			ve:SetScript("OnLeave", function(self) veb:SetVertexColor(cfg.colors.normal.r, cfg.colors.normal.g, cfg.colors.normal.b) end)
		elseif (((event=="UNIT_EXITING_VEHICLE") or (event=="UNIT_EXITED_VEHICLE")) and arg1 == "player") or (event=="ZONE_CHANGED_NEW_AREA" and not UnitHasVehicleUI("player")) then
			ve:SetAlpha(0)
		end
	end)  
end

-- MicroMenu
local MicroMenu = mAB.CreateHolder("holder_MicroMenu", {a= cfg.config_micromenu["Position"].a, x=cfg.config_micromenu["Position"].x*(2-cfg.config_micromenu[3]), y= cfg.config_micromenu["Position"].y*(2-cfg.config_micromenu[3])})
MicroMenu:SetSize(255,40)
MicroMenu:SetScale(cfg.config_micromenu[3])
local MicroButtons = {
	CharacterMicroButton,
	SpellbookMicroButton,
	TalentMicroButton,
	AchievementMicroButton,
	QuestLogMicroButton,
	GuildMicroButton,
	PVPMicroButton,
	LFDMicroButton,
	MainMenuMicroButton,
	HelpMicroButton} 
local SetMicroButtons = function() 
    for _, b in pairs(MicroButtons) do
		b:SetParent(MicroMenu)
    end
    CharacterMicroButton:ClearAllPoints();
    CharacterMicroButton:SetPoint("BOTTOMLEFT", 0, 0)
end
SetMicroButtons()
-- gotta run this function each time we respec so we don't loose our micromenu bar
MicroMenu:RegisterEvent("PLAYER_TALENT_UPDATE")
MicroMenu:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
MicroMenu:SetScript("OnEvent", function(self,event) 
      if  not InCombatLockdown() and (event == "PLAYER_TALENT_UPDATE" or event == "ACTIVE_TALENT_GROUP_CHANGED") then
          SetMicroButtons()
      end
end)
-- micro menu on mouseover
if cfg.config_micromenu[2] then    
	local switcher = -1
	local function mmalpha(alpha)
		for _, f in pairs(MicroButtons) do
			f:SetAlpha(alpha)
			switcher = alpha
		end
	end
	MicroMenu:EnableMouse(true)
	MicroMenu:SetScript("OnEnter", function(self) mmalpha(1) end)
	MicroMenu:SetScript("OnLeave", function(self) mmalpha(0) end)
	for _, f in pairs(MicroButtons) do
		f:SetAlpha(0)
		f:HookScript("OnEnter", function(self) mmalpha(1) end)
		f:HookScript("OnLeave", function(self) mmalpha(0) end)
	end
	MicroMenu:SetScript("OnEvent", function(self) 
		mmalpha(0) 
	end)
	MicroMenu:RegisterEvent("PLAYER_ENTERING_WORLD")
	--fix for the talent button display while micromenu onmouseover
	local function TalentSwitchAlphaFix(self,alpha)
		if switcher ~= alpha then
			switcher = 0
			self:SetAlpha(0)
		end
		SetMicroButtons()
	end
	hooksecurefunc(TalentMicroButton, "SetAlpha", TalentSwitchAlphaFix)
end

-- fix main bar keybind not working after a talent switch, credits to tukz/evl22
hooksecurefunc('TalentFrame_LoadUI', function()
	PlayerTalentFrame:UnregisterEvent('ACTIVE_TALENT_GROUP_CHANGED')
end)

-- rescale cooldown spiral to fix texture.
local buttonNames = { "ActionButton",  "MultiBarBottomLeftButton", "MultiBarBottomRightButton", "MultiBarLeftButton", "MultiBarRightButton", "ShapeshiftButton", "PetActionButton"}
for _, name in ipairs( buttonNames ) do
	for index = 1, 12 do
		local buttonName = name .. tostring(index)
		local button = _G[buttonName]
		local cooldown = _G[buttonName .. "Cooldown"]
 		if ( button == nil or cooldown == nil ) then
			break
		end
		cooldown:ClearAllPoints()
		cooldown:SetPoint("TOPLEFT", button, "TOPLEFT", 2, -2)
		cooldown:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 2)
	end
end

-- hiding extra bars
local bars_visible
if cfg.hide_side_bars then
	leftbar:Hide()
	rightbar:Hide()
	extrabar:Hide()
	bars_visible = false
end
if cfg.config_micromenu[1] then MicroMenu:Hide() end

-- making this global function to hook in my broker toggler
m_ActionBars_Toggle_Extra_Bars = function()
	if InCombatLockdown() then return print("m_ActionBars: You can't toggle bars while in combat!") end
	if bars_visible then 
		if cfg.hide_side_bars then
			leftbar:Hide()
			rightbar:Hide()
			extrabar:Hide()
		end
		if cfg.config_shapeshiftbar[6] then shapeshiftbar:Hide() end
		if cfg.config_micromenu[1] then MicroMenu:Hide() end
		if holder_WorldMarkBar and cfg.config_markerflarebar[4] then holder_WorldMarkBar:Hide() end
		if holder_RaidMarkBar and cfg.config_raidiconbar[4] then holder_RaidMarkBar:Hide() end
		bars_visible = false
	else
		if cfg.hide_side_bars then
			leftbar:Show()
			rightbar:Show()
			extrabar:Show()
		end
		if cfg.config_shapeshiftbar[6] then shapeshiftbar:Show() end
		if cfg.config_micromenu[1] then MicroMenu:Show() end
		if cfg.config_markerflarebar[4] and holder_WorldMarkBar then holder_WorldMarkBar:Show() end
		if cfg.config_raidiconbar[4] and holder_RaidMarkBar then holder_RaidMarkBar:Show() end
		bars_visible = true
	end
end

-- and making slash command to show them
SlashCmdList["EXTRA"] = function() m_ActionBars_Toggle_Extra_Bars() end
SLASH_EXTRA1 = "/extra"
SLASH_EXTRA2 = "/eb"

-- adding testmode to make bar positioning easier
local testmodeON
m_ActionBars_Toggle_Test_Mode = function()
	local def_back		= "interface\\Tooltips\\UI-Tooltip-Background"
	local backdrop_tab = { 
		bgFile = def_back, 
		edgeFile = nil,
		tile = false, tileSize = 0, edgeSize = 5, 
		insets = {left = 0, right = 0, top = 0, bottom = 0,},}
	local ShowHolder = function(holder, switch)
		if not _G[holder:GetName().."_overlay"] then
			local f = CreateFrame("Frame", holder:GetName().."_overlay")
			f:SetAllPoints(holder)
			f:SetBackdrop(backdrop_tab);
			f:SetBackdropColor(.1,.1,.2,.8)
			f:SetFrameStrata("HIGH")
			local name = f:CreateFontString(nil) 
			name:SetFont("Fonts\\FRIZQT__.TTF",8)
			name:SetText(holder:GetName())
			name:SetPoint("BOTTOMLEFT",f,"TOPLEFT")
		end

		if switch then
			_G[holder:GetName().."_overlay"]:Show()
		else
			_G[holder:GetName().."_overlay"]:Hide()
		end
	end
	if testmodeON then 
		testmodeON = false
	else
		testmodeON = true
	end
	local holders = {
		holder_MainBar,
		holder_MultiBarBottomLeftBar,
		holder_MultiBarBottomRightBar,
		holder_MultiBarLeftBar,
		holder_MultiBarRightBar,
		holder_ShapeShiftBar,
		holder_PetBar,
		holder_MicroMenu,
		holder_RaidMarkBar,
		holder_WorldMarkBar,
		holder_VEB,
		holder_ExtraBar}
	for _, f in pairs(holders) do
		ShowHolder(f,testmodeON)
	end
	if cfg.enable_totembar and myclass == "SHAMAN" then ShowHolder(holder_TotemBar,testmodeON) end
end
SlashCmdList["TESTMODE"] = function() m_ActionBars_Toggle_Test_Mode() end
SLASH_TESTMODE1 = "/mab"