  local addon, ns = ...
  local cfg = CreateFrame("Frame")

  -----------------------------
  -- MEDIA
  -----------------------------
  local MediaPath = "Interface\\Addons\\m_ActionBars\\media\\"
  cfg.textures_normal = MediaPath.."icon"
  cfg.textures_pushed = MediaPath.."icon"
  cfg.button_font = "Interface\\AddOns\\kMedia\\fonts\\ROADWAY.ttf"
  
  -----------------------------
  -- CONFIG
  -----------------------------
  --ActionBars config
  cfg.enable_action_bars = true		-- enable action bars modifications
  cfg.size = 32						-- setting up default buttons size
  cfg.spacing = 2					-- spacing between buttons
  cfg.hide_side_bars = false		-- hiding LeftBar and RightBar making them available via /extra or /eb command

  cfg.config_mainbar = {		
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 2,	--[[buttons:]] 12,	
	--[[button size:]] cfg.size,	--[[spacing between buttons:]] cfg.spacing,
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0.5,
	["Position"] = { a= "BOTTOM",		x=	0,		y= 244	}
	}
  cfg.config_bottomleftbar = {	
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,					
	--[[button size:]] cfg.size,	--[[spacing between buttons:]] cfg.spacing,
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0.5,
	["Position"] = { a= "BOTTOM",		x=	0,		y= 36	}
  	}
  cfg.config_bottomrightbar = {	
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,					
	--[[button size:]] cfg.size,			--[[spacing between buttons:]] cfg.spacing,
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0,
	["Position"] = { a= "BOTTOM",	x=	0,	y= 2	}
  	}
  cfg.config_leftbar = {		
	--[[orientation:]] "V",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,
	--[[button size:]] 30, 			--[[spacing between buttons:]] cfg.spacing,
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0,
	["Position"] = { a= "BOTTOMRIGHT",	x=	-34, y= 190	}
 	}
  cfg.config_rightbar = {		
	--[[orientation:]] "V",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,
	--[[button size:]] 30,			--[[spacing between buttons:]] cfg.spacing,
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0,
	["Position"] = { a= "BOTTOMRIGHT",	x=	-2,	y= 190	}
	}
  cfg.config_shapeshiftbar = {	
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 6,	
	--[[button size:]] 22, 			--[[spacing between buttons:]] cfg.spacing,	
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0,
	["Position"] = {  a= "BOTTOM",		x=	-10,	y= 220	}
	}
  cfg.config_petbar = {			
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] NUM_PET_ACTION_SLOTS,	
	--[[button size:]] cfg.size,	--[[spacing between buttons:]] cfg.spacing,	
	--[[disable bar:]] false,		--[[show on mouseover:]] true,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] .3,
	["Position"] = { a= "BOTTOM",		x=	-32,	y= 88	}
	}
  cfg.config_extrabar = {		
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,
	--[[button size:]] 30,			--[[spacing between buttons:]] cfg.spacing,
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,  			--[[fade out alpha:]] .3,
	["Position"] = { a= "BOTTOMRIGHT",	x=	-26,	y= 260	}
	}
  cfg.config_totembar = {	
	--[[enable timers:]] true,		--[[button size:]] 24,			--[[spacing between buttons:]] 2,	
	--[[disable bar:]] false, 		--[[bar alpha:]] 1,
	["Position"] = { a= "BOTTOM",		x=	0,  	y= 67	}
	}
  cfg.config_raidiconbar = {	
	--[[orientation:]] "H",			--[[button size:]] 20,  		--[[spacing between buttons:]] 1,	
	--[[disable bar:]] false,		--[[show on mouseover:]] true,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0.2,
	["Position"] = { a= "BOTTOM",		x=	320,  	y= 3	}
	}
  cfg.config_markerflarebar = {	
	--[[orientation:]] "V",			--[[button size:]] 20,			--[[spacing between buttons:]] 1,	
	--[[disable bar:]] false,		--[[show on mouseover:]] true,	--[[show only when in group:]] true,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0.2,
	["Position"] = { a= "BOTTOMLEFT",	x=	438,	y= 2	}
	}
  cfg.config_micromenu = {	
	--[[disable bar:]] true,		--[[show on mouseover:]] false,	--[[scale:]] 0.85,
	["Position"] = { a= "BOTTOMRIGHT",	x=	-25,	y= 300	}
	}
  cfg.config_exitvehiclebtn = {	
	--[[disable:]] false,  			--[[user placed:]] false,
	["Position"] = { a= "BOTTOM",		x=	-380,	y= 238	}
	}
	
  --ButtonsStyler config
  cfg.hide_hotkey = false		-- remove key binding text from the bars
  cfg.hide_macro_name = false	-- remove macro name text from the bars
  cfg.count_font_size = 18		-- remove count text from the bars
  cfg.hotkey_font_size = 16		-- font size for the key bindings text
  cfg.name_font_size = 14		-- font size for the macro name text
  cfg.colors = {
       normal = {r =  0,	g =  0, 	b =  0	},
       pushed = {r =  1,	g =  1, 	b =  1	},
    highlight = {r =  .9,	g =  .8,	b =  .6	},
      checked = {r =  .9,	g =  .8,	b =  .6	},
   outofrange = {r =  .8,	g =  .3, 	b =  .2	},
    outofmana = {r =  .3,	g = .3, 	b =  .7	},
       usable = {r =  1,	g =  1, 	b =  1	},
     unusable = {r = .4,	g = .4, 	b = .4	}
  }
  
  -- HANDOVER
  ns.cfg = cfg
