  local addon, ns = ...
  local cfg = CreateFrame("Frame")

  -----------------------------
  -- MEDIA
  -----------------------------
  local MediaPath = "Interface\\Addons\\m_ActionBars\\media\\"
  cfg.textures_normal = MediaPath.."icon"
  cfg.textures_pushed = MediaPath.."icon"
  cfg.button_font = "Fonts\\FRIZQT__.TTF"
  
  -----------------------------
  -- CONFIG
  -----------------------------
  --ActionBars config
  cfg.enable_action_bars = true		-- enable action bars modifications
  cfg.size = 30						-- setting up default buttons size
  cfg.spacing = 2					-- spacing between buttons
  cfg.hide_side_bars = true			-- hiding LeftBar and RightBar making them available via /extra or /eb command

  cfg.config_mainbar = {			-- BAR 1
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,	
	--[[button size:]] cfg.size,	--[[spacing between buttons:]] cfg.spacing,
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0.5,
	["Position"] = { a= "BOTTOM",		x=	0,		y= 10	}
	}
  cfg.config_bottomleftbar = {		-- BAR 2
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,					
	--[[button size:]] cfg.size,	--[[spacing between buttons:]] cfg.spacing,
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0.5,
	["Position"] = { a= "BOTTOM",		x=	0,		y= 45	}
  	}
  cfg.config_bottomrightbar = {		-- BAR 3
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,					
	--[[button size:]] cfg.size,			--[[spacing between buttons:]] cfg.spacing,
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0,
	["Position"] = { a= "BOTTOM",   	x=	0,  	y= 80	}
  	}
  cfg.config_leftbar = {			-- BAR 4
	--[[orientation:]] "V",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,
	--[[button size:]] cfg.size, 			--[[spacing between buttons:]] cfg.spacing,
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0,
	["Position"] = { a= "RIGHT",   	x=	-35,  	y= 0	}
 	}
  cfg.config_rightbar = {			-- BAR 5
	--[[orientation:]] "V",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,
	--[[button size:]] cfg.size,			--[[spacing between buttons:]] cfg.spacing,
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0,
	["Position"] = { a= "RIGHT",   	x=	-70,  	y= 0	}
	}
  cfg.config_extrabar = {			-- BAR 6
	--[[orientation:]] "V",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 12,
	--[[button size:]] cfg.size,			--[[spacing between buttons:]] cfg.spacing,
	--[[disable bar:]] false,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,  			--[[fade out alpha:]] .3,
	["Position"] = { a= "RIGHT",   	x=	-105,  	y= 0	}
	}
  cfg.config_shapeshiftbar = {	
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] 6,	
	--[[button size:]] 30, 			--[[spacing between buttons:]] cfg.spacing,	
	--[[disable bar:]] true,		--[[show on mouseover:]] false,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0,
	["Position"] = { a= "BOTTOM",   	x=	-96,  	y= 115	}
	}
  cfg.config_petbar = {			
	--[[orientation:]] "H",			--[[rows(H)/columns(V):]] 1,	--[[buttons:]] NUM_PET_ACTION_SLOTS,	
	--[[button size:]] cfg.size,	--[[spacing between buttons:]] cfg.spacing,	
	--[[disable bar:]] false,		--[[show on mouseover:]] true,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] .3,
	["Position"] = { a= "BOTTOM",		x=	0,  	y= 147	}
	}
  cfg.config_totembar = {	
	--[[enable timers:]] true,		--[[button size:]] 32,			--[[spacing between buttons:]] 8,	
	--[[disable bar:]] false, 		--[[bar alpha:]] 1,
	["Position"] = { a= "BOTTOM",		x=	0,  	y= 238	}
	}
  cfg.config_raidiconbar = {	
	--[[orientation:]] "V",			--[[button size:]] 20,  		--[[spacing between buttons:]] 3,	
	--[[disable bar:]] true,		--[[show on mouseover:]] true,	--[[show when in combat:]] false,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0.2,
	["Position"] = { a= "RIGHT",		x=	-10,  	y= -77	}
	}
  cfg.config_markerflarebar = {	
	--[[orientation:]] "V",			--[[button size:]] 20,			--[[spacing between buttons:]] cfg.spacing,	
	--[[disable bar:]] true,		--[[show on mouseover:]] true,	--[[show only when in group:]] true,
	--[[bar alpha:]] 1,				--[[fade out alpha:]] 0.2,
	["Position"] = { a= "RIGHT",    	x=	-10,	y= 122	}
	}
  cfg.config_micromenu = {	
	--[[disable bar:]] true,		--[[show on mouseover:]] false,	--[[scale:]] 0.85,
	["Position"] = { a= "BOTTOM",   	x=	87,	y= 115	}
	}
  cfg.config_exitvehiclebtn = {	
	--[[disable:]] false,  			--[[user placed:]] false,
	["Position"] = { a= "BOTTOM",		x=	-380,	y= 238	}
	}
	
  --ButtonsStyler config
  cfg.hide_hotkey = true		-- remove key binding text from the bars
  cfg.hide_macro_name = true	-- remove macro name text from the bars
  cfg.count_font_size = 12		-- remove count text from the bars
  cfg.hotkey_font_size = 11		-- font size for the key bindings text
  cfg.name_font_size = 8		-- font size for the macro name text
  cfg.colors = {
       normal = {r =  0,	g =  0, 	b =  0	},
       pushed = {r =  1,	g =  1, 	b =  1	},
    highlight = {r =  .9,	g =  .8,	b =  .6	},
      checked = {r =  .9,	g =  .8,	b =  .6	},
   outofrange = {r =  .8,	g =  .3, 	b =  .2	},
    outofmana = {r =  .3,	g = .3, 	b =  .7	},
       usable = {r =  1,	g =  1, 	b =  1	},
     unusable = {r = .4,	g = .4, 	b = .4	}
  }
  
  -- HANDOVER
  ns.cfg = cfg
