local addon, ns = ...
local cfg = ns.cfg
local mAB = CreateFrame("Frame")

---- Addon functions
local myclass = select(2, UnitClass("player"))

-- holder creating func
mAB.CreateHolder = function(name, pos)
	local bar = CreateFrame("Frame", name, UIParent, "SecureHandlerStateTemplate")
	bar:SetPoint(pos.a, pos.x, pos.y)
	return bar
end 

-- style function for bars
mAB.SetBar = function(bar, button, b1, num, orient, rows, visnum, bsize, spacing)
	local pad = spacing or cfg.spacing
	local first_row_num = math.floor(visnum/rows)
	for i = b1, num do
		_G[button..i]:ClearAllPoints()
		_G[button..i]:SetSize(bsize,bsize)
		if i == 1 then
			_G[button..i]:SetPoint("TOPLEFT", bar, "TOPLEFT", 0, 0)
		else
			if orient == "H" then
				if rows == 1 then
					_G[button..i]:SetPoint("TOPLEFT", _G[button..(i-1)], "TOPRIGHT", pad, 0)
				else
					_G[button..i]:SetPoint("TOPLEFT", _G[button..(i-1)], "TOPRIGHT", pad, 0)
					if i == first_row_num+1 then
						_G[button..i]:SetPoint("TOPLEFT", _G[button..(i-first_row_num)], "BOTTOMLEFT", 0, -pad)
					end
					if i == first_row_num*2+1 then
						_G[button..i]:SetPoint("TOPLEFT", _G[button..(i-first_row_num)], "BOTTOMLEFT", 0, -pad)
					end
				end
			else
				if rows == 1 then
					_G[button..i]:SetPoint("TOPLEFT", _G[button..(i-1)], "BOTTOMLEFT", 0, -pad)
				else
					_G[button..i]:SetPoint("TOPLEFT", _G[button..(i-1)], "BOTTOMLEFT", 0, -pad)
					if i == first_row_num+1 then
						_G[button..i]:SetPoint("TOPLEFT", _G[button..(i-first_row_num)], "TOPRIGHT", pad, 0)
					end
					if i==first_row_num*2+1 then
						_G[button..i]:SetPoint("TOPLEFT", _G[button..(i-first_row_num)], "TOPRIGHT", pad, 0)
					end
				end
			end
			if i > visnum then 
				_G[button..i]:UnregisterAllEvents()
				_G[button..i]:SetScale(0.00001)
				_G[button..i]:SetAlpha(0)
				_G[button..i]:Hide()
			end
		end
		_G[button..i].SetPoint = function() end
	end
	if orient == "H" then
		if rows == 1 then
			bar:SetWidth(bsize*visnum + pad*(visnum-1))
			bar:SetHeight(bsize)
		else
			bar:SetWidth(bsize*first_row_num + pad*(first_row_num-1))
			bar:SetHeight(bsize*rows+pad)
		end
	else
		if rows == 1 then
			bar:SetWidth(bsize)
			bar:SetHeight(bsize*visnum + pad*(visnum-1))
		else
			bar:SetWidth(bsize*rows+pad)
			bar:SetHeight(bsize*first_row_num + pad*(first_row_num-1))
		end
	end
end

-- modified styling function for Extra Action Bar
mAB.SetExtraBar = function(bar, bname, b1, num, orient, rows, visnum, bsize, spacing)
	local pad = spacing or cfg.spacing
	local first_row_num = math.floor(visnum/rows)
	for i = b1, num do
		local btn = CreateFrame("CheckButton", bname..(i-12), UIParent, "ActionBarButtonTemplate")
		btn:SetAttribute("action", i)
		btn:SetID(i)
		btn:ClearAllPoints()
		btn:SetSize(bsize,bsize)
		btn:SetParent(bar)
		if i == 13 then
			btn:SetPoint("TOPLEFT", bar, "TOPLEFT", 0, 0)
		else
			if orient == "H" then
				if rows == 1 then
					btn:SetPoint("TOPLEFT", _G[bname..(i-13)], "TOPRIGHT", pad, 0)
				else
					btn:SetPoint("TOPLEFT", _G[bname..(i-13)], "TOPRIGHT", pad, 0)
					if i == 12+first_row_num+1 then
						btn:SetPoint("TOPLEFT", _G[bname..(i-first_row_num-12)], "BOTTOMLEFT", 0, -pad)
					end
					if i == 12+first_row_num*2+1 then
						btn:SetPoint("TOPLEFT", _G[bname..(i-first_row_num-12)], "BOTTOMLEFT", 0, -pad)
					end
				end
			else
				if rows == 1 then
					btn:SetPoint("TOPLEFT", _G[bname..(i-13)], "BOTTOMLEFT", 0, -pad)
				else
					btn:SetPoint("TOPLEFT", _G[bname..(i-13)], "BOTTOMLEFT", 0, -pad)
					if i == 12+first_row_num+1 then
						btn:SetPoint("TOPLEFT", _G[bname..(i-first_row_num-12)], "TOPRIGHT", pad, 0)
					end
					if i == 12+first_row_num*2+1 then
						btn:SetPoint("TOPLEFT", _G[bname..(i-first_row_num-12)], "TOPRIGHT", pad, 0)
					end
				end
			end
 			if i > visnum+12 then 
				btn:UnregisterAllEvents()
				btn:SetScale(0.00001)
				btn:SetAlpha(0)
				btn:Hide()
			end
		end
		btn.SetPoint = function() end
	end
	if orient == "H" then
		if rows == 1 then
			bar:SetWidth(bsize*visnum + pad*(visnum-1))
			bar:SetHeight(bsize)
		else
			bar:SetWidth(bsize*first_row_num + pad*(first_row_num-1))
			bar:SetHeight(bsize*rows+pad)
		end
	else
		if rows == 1 then
			bar:SetWidth(bsize)
			bar:SetHeight(bsize*visnum + pad*(visnum-1))
		else
			bar:SetWidth(bsize*rows+pad)
			bar:SetHeight(bsize*first_row_num + pad*(first_row_num-1))
		end
	end
end

-- mouseover visibility condition
mAB.SetBarAlpha = function(bar,button,num,switch,baralpha,fadealpha)
	if switch then
		local function lighton(alpha)
		  if bar and bar:IsShown() then
			for i=1, num do
			  local pb = _G[button..i]
			  pb:SetAlpha(alpha)
			end
		  end
		end    
		bar:EnableMouse(true)
		bar:SetScript("OnEnter", function(self) lighton(1) end)
		bar:SetScript("OnLeave", function(self) lighton(fadealpha or 0) end)  
		for i=1, num do
		  local pb = _G[button..i]
		  pb:SetAlpha(fadealpha or 0)
		  pb:HookScript("OnEnter", function(self) lighton(1) end)
		  pb:HookScript("OnLeave", function(self) lighton(fadealpha or 0) end)
		end
	end
	bar:SetAlpha(baralpha or 1)
end

-- combat visibility condition
mAB.ShowInCombat = function(bar)
	bar:RegisterEvent("PLAYER_REGEN_DISABLED")
	bar:RegisterEvent("PLAYER_REGEN_ENABLED")
	bar:RegisterEvent("PLAYER_ENTERING_WORLD")
	bar:Hide()
	bar:SetScript("OnEvent", function(self, event, ...)
		if event == "PLAYER_REGEN_DISABLED" then 
			bar:Show()
		elseif event == "PLAYER_REGEN_ENABLED" then 
			bar:Hide()
		end
	end)
end

ns.mAB = mAB